drew.fg.core = function() {
  var core = {};
  core.onstartup = function(start) {
    if (drew.fg.ls.get("on") === false) {
    } else {
      drew.fg.core.LoadConf();
      drew.fg.core.GetBlList(function() {
        drew.fg.proxy.set(start);
        drew.fg.core.setIco();
      });
    }
  };
  core.GetBlList = function(callbackl) {
    var date = new Date;
    drew.fg.bl.enabled = drew.fg.ls.get("bl_enabled");
    if (drew.fg.bl.enabled && drew.fg.bl.apiurl.length > 0 && drew.fg.bl.ext < date.getTime()) {
      ldb.get("bl3", function(value) {
        drew.fg.bl.list = JSON.parse(value);
      });
      drew.fg.lib.shuffle(drew.fg.bl.apiurl);
      var firstRandomElement = drew.fg.bl.apiurl[0] + "/json";
      drew.fg.lib.debug(1, firstRandomElement);
      drew.fg.lib.ReqJson(firstRandomElement, 1E3 * 30, function(resp) {
        drew.fg.bl.list = JSON.parse(resp);
        ldb.set("bl3", JSON.stringify(drew.fg.bl.list), function() {
        });
        drew.fg.bl.ext = date.getTime() + 60 * 60 * 1000 * 12;
        callbackl();
      }, function(resp) {
        callbackl();
      }, function(resp) {
        callbackl();
      });
    } else {
      callbackl();
    }
  };
  core.LoadConf = function() {
    var proxy = drew.fg.ls.get("proxy");
    var fp = drew.fg.ls.get("fp2");
    var i;
    var is_fp = false;
    var url = [];
    var apiurl = [];
    var redirectURL = chrome.identity.getRedirectURL();
    if (proxy === null || typeof proxy !== "object") {
      return false;
    }
    while (i = fp.shift()) {
      var len = proxy.length;
      while (len--) {
        var proxy_unparse = drew.fg.proxy.parse(proxy[len].h);
        if (drew.fg.lib.shExpMatch(proxy_unparse.proxy_host, i)) {
          is_fp = true;
          url.push(proxy_unparse.proxy_host);
        }
      }
    }
    if (!is_fp) {
      drew.fg.ls.set("f3proxy", 0);
      return false;
    }
    drew.fg.ls.set("f3proxy", 1);
    url = drew.fg.lib.uniq(url);
    if (url.length > 1) {
      var rand = Math.floor(Math.random() * url.length);
      apiurl.push("https://" + url[rand] + ":80");
      var rand2 = Math.floor(Math.random() * url.length);
      while (rand === rand2) {
        rand2 = Math.floor(Math.random() * url.length);
      }
      apiurl.push("https://" + url[rand2] + ":80");
    } else {
      apiurl.push("https://" + url[0] + ":80");
    }
    drew.fg.bl.apiurl = apiurl.slice(0);
    var date = new Date;
    var j;
    while (j = apiurl.shift()) {
      if (drew.fg.token.hasOwnProperty("ext") && drew.fg.token.ext > date.getTime()) {
        drew.fg.core.sendreq(j);
      } else {
        chrome.identity.launchWebAuthFlow({interactive:false, url:j + "/oa?client_id&redirect_uri=" + redirectURL}, function(redirectURL) {
          drew.fg.lib.debug(0, redirectURL);
          if (redirectURL) {
            drew.fg.token.v = redirectURL.split("=")[1];
            if (drew.fg.token.v.length > 31) {
              drew.fg.token.ext = date.getTime() + 60 * 60 * 1000;
              drew.fg.core.sendreq(this);
            }
          } else {
            chrome.alarms.create("LoadConfOnErr", {when:Date.now() + drew.fg.conf.apitoerr});
          }
        }.bind(j));
      }
    }
  };
  core.sendreq = function(i) {
    var post = "";
    drew.fg.lib.ReqJson(i + "/ff2?token=" + drew.fg.token.v, 1E3 * 30, function(response) {
      response = drew.fg.lib.trim(response);
      drew.fg.lib.debug(0, "onSuccess " + response);
      if (response === "ok") {
        drew.fg.ls.set("lastgetapi", Date.now() + drew.fg.conf.apito * 60 * 1000);
      } else {
        if (response === "err0") {
          drew.fg.token.ext = 0;
          drew.fg.core.LoadConf();
        }
        chrome.alarms.create("LoadConfOnErr", {when:Date.now() + drew.fg.conf.apitoerr});
      }
    }, function() {
      drew.fg.token.ext = 0;
      drew.fg.lib.debug(0, "onError");
      chrome.alarms.create("LoadConfOnErr", {when:Date.now() + drew.fg.conf.apitoerr});
    }, function() {
      drew.fg.token.ext = 0;
      drew.fg.lib.debug(0, "onTimeout");
      chrome.alarms.create("LoadConfOnErr", {when:Date.now() + drew.fg.conf.apitoerr});
    }, "POST", post);
  };
  core.oninstalled = function(proxyload, callbackl) {
    var proxyset = [];
    if (drew.fg.ls.get("on") == null) {
      for (var key in drew.fg.conf) {
        if (!drew.fg.conf.hasOwnProperty(key)) {
          continue;
        }
        drew.fg.ls.set("conf." + key, drew.fg.conf[key]);
      }
      drew.fg.ls.set("bl_enabled", true);
      drew.fg.ls.set("mode", 2);
      drew.fg.ls.set("mode2", 1);
      drew.fg.ls.set("fp", ["*.friproxy*", "*.fri-gate*"]);
      var proxyloadarr = JSON.parse(proxyload);
      if (typeof proxyloadarr === "object" && Object.keys(proxyloadarr).length > 1) {
        var i;
        var proxyloadstr = proxyloadarr.join("\n");
        drew.fg.ls.set("proxyloadstr", proxyloadstr);
      } else {
        proxyset = [{"co":"RU", "h":"https://ru-200-64-234.friproxy0.biz:443"}, {"co":"RU", "h":"https://ru-200-64-235.fri-gate0.biz:443"}, {"co":"RU", "h":"https://ru-200-64-236.friproxy.biz:443"}, {"co":"RU", "h":"https://ru-200-64-237.friproxy0.biz:443"}, {"co":"RU", "h":"https://ru-251-80-155.friproxy.biz:443"}, {"co":"RU", "h":"https://ru-251-80-156.friproxy0.biz:443"}, {"co":"RU", "h":"https://ru-251-80-157.friproxy0.biz:443"}, {"co":"RU", "h":"https://ru-251-80-158.friproxy.biz:443"}];
        var i$0;
        var proxysetru = [], proxysetnotru = [];
        while (i$0 = proxyset.shift()) {
          if (i$0.co == "RU") {
            proxysetru.push(i$0);
          } else {
            proxysetnotru.push(i$0);
          }
        }
        drew.fg.lib.shuffle(proxysetnotru);
        drew.fg.lib.shuffle(proxysetru);
        proxyset = proxysetnotru.concat(proxysetru);
        drew.fg.ls.set("proxy", proxyset);
      }
      chrome.tabs.create({"url":window.chrome.extension.getURL("/html/start_wizard.html"), "active":true});
    }
    if (drew.fg.ls.get("fp2") == null) {
      drew.fg.ls.set("fp2", ["*.friproxy*", "*.fri-gate*"]);
    }
    drew.fg.ls.set("md5.pr", "");
    chrome.alarms.clearAll(function() {
      chrome.proxy.settings.clear({scope:"regular"}, function() {
        chrome.alarms.create("LoadConf", {when:Date.now() + drew.fg.conf.apito * 60 * 1000, periodInMinutes:drew.fg.conf.apito});
        chrome.alarms.onAlarm.addListener(function(alarm) {
          if (alarm.name === "LoadConf") {
            drew.fg.core.LoadConf();
          }
          if (alarm.name === "LoadConfOnErr") {
            drew.fg.core.LoadConf();
          }
        });
        if (callbackl) {
          callbackl();
        }
      });
    });
  };
  core.checkUrl = function(url) {
    var i;
    var sites = drew.fg.ls.get("sites");
    if (!sites || typeof sites !== "object" || sites.length < 1) {
      return false;
    }
    var tmp_url_split = url.split("://");
    if (tmp_url_split[0] !== "http" && tmp_url_split[0] !== "https") {
      return false;
    }
    tmp_url_split = tmp_url_split[1].split("/");
    while (i = sites.shift()) {
      if (i.h === tmp_url_split[0] || drew.fg.lib.shExpMatch(tmp_url_split[0], i.h)) {
        return true;
      }
    }
    if (drew.fg.bl.enabled && Object.keys(drew.fg.bl.list).length > 0) {
      if (tmp_url_split[0] in drew.fg.bl.list) {
        return true;
      }
      var hostSplitDot = tmp_url_split[0].split(".");
      var hostSplitDotLength = hostSplitDot.length;
      if (hostSplitDotLength > 2) {
        var subdomain = hostSplitDot[hostSplitDotLength - 1];
        for (var i$1 = hostSplitDotLength - 2; i$1 > 0; i$1--) {
          subdomain = hostSplitDot[i$1] + "." + subdomain;
          if (subdomain in drew.fg.bl.list) {
            return true;
          }
        }
      }
    }
    return false;
  };
  core.setIco = function() {
    if (drew.fg.ls.get("on") === false) {
      chrome.browserAction.setIcon({path:"/im/ico/38g.png"});
    } else {
      chrome.tabs.getSelected(null, function(tab) {
        if (drew.fg.ls.get("mode") == 3) {
          chrome.browserAction.setIcon({path:"/im/ico/38a.png"});
        } else {
          if (drew.fg.core.checkUrl(tab.url)) {
            chrome.browserAction.setIcon({path:"/im/ico/38a.png"});
          } else {
            chrome.browserAction.setIcon({path:"/im/ico/38.png"});
          }
        }
      });
    }
  };
  core.cuthist = function() {
    var ret = {};
    var keysSorted = Object.keys(drew.fg.timehist).sort(function(a, b) {
      return drew.fg.timehist[b] - drew.fg.timehist[a];
    }).reduce(function(a, v) {
      a[v] = drew.fg.timehist[v];
      return a;
    }, {});
    var count = 0;
    for (var index in keysSorted) {
      if (!keysSorted.hasOwnProperty(index)) {
        continue;
      }
      count++;
      if (count > 5) {
        delete keysSorted[index];
      } else {
        ret[index] = drew.fg.histall[index];
      }
    }
    for (var index$2 in drew.fg.histall) {
      if (!drew.fg.histall.hasOwnProperty(index$2)) {
        continue;
      }
      if (!keysSorted.hasOwnProperty(index$2)) {
        delete drew.fg.histall[index$2];
      } else {
      }
    }
    return ret;
  };
  core.gethist = function() {
    return core.cuthist();
  };
  core.start = function() {
    chrome.runtime.onStartup.addListener(function() {
      drew.fg.lib.debug(100, "onStartup");
      drew.fg.core.setIco();
    });
    chrome.webRequest.onAuthRequired.addListener(function(details) {
      if (!details.isProxy) {
        return;
      }
      var h = details.challenger.host + ":" + details.challenger.port;
      if (typeof drew.fg.auth[h] === "object" && drew.fg.auth[h].hasOwnProperty("l") && drew.fg.auth[h].hasOwnProperty("p")) {
        return {authCredentials:{"username":drew.fg.auth[h].l, "password":drew.fg.auth[h].p}};
      }
    }, {urls:["<all_urls>"]}, ["blocking"]);
    chrome.webRequest.onBeforeRequest.addListener(function(details) {
      drew.fg.core.setIco();
      if (!details || !details.url) {
        return;
      }
      var purl = drew.fg.lib.parse_url(details.url);
      if (purl === false || purl.protocol !== "http:" && purl.protocol !== "https:") {
        return;
      }
      var wildcard_host = drew.fg.lib.create_host_wildcard(purl.host);
      drew.fg.hist[details.tabId] = {"mf":wildcard_host, "t":Date.now()};
      drew.fg.timehist[wildcard_host] = Date.now();
    }, {urls:["<all_urls>"], types:["main_frame"]}, ["blocking"]);
    chrome.webRequest.onCompleted.addListener(function() {
      drew.fg.core.setIco();
    }, {urls:["<all_urls>"], types:["main_frame"]});
    chrome.webRequest.onBeforeRedirect.addListener(function() {
      drew.fg.core.setIco();
    }, {urls:["<all_urls>"]});
    chrome.webNavigation.onCommitted.addListener(function(e) {
      drew.fg.core.setIco();
    }, {urls:["<all_urls>"]});
    chrome.tabs.onActivated.addListener(drew.fg.core.setIco);
    chrome.webRequest.onBeforeRequest.addListener(function(details) {
      if (!details || !details.url) {
        return;
      }
      var purl = drew.fg.lib.parse_url(details.url);
      if (purl === false || purl.protocol !== "http:" && purl.protocol !== "https:") {
        return;
      }
      if (details.tabId > -1) {
        if (!drew.fg.hist.hasOwnProperty(details.tabId)) {
          return;
        }
        var parent_host = drew.fg.hist[details.tabId].mf;
        var wildcard_host = drew.fg.lib.create_host_wildcard(purl.host);
        if (wildcard_host === parent_host) {
          return;
        }
        if (!drew.fg.histall.hasOwnProperty(parent_host)) {
          drew.fg.histall[parent_host] = [];
        }
        if (drew.fg.lib.Array_contains(wildcard_host, drew.fg.histall[parent_host])) {
          return;
        }
        if (drew.fg.lib.shExpMatch(purl.host, parent_host)) {
          return;
        }
        var len = drew.fg.histall[parent_host].length;
        while (len--) {
          if (drew.fg.lib.shExpMatch(purl.host, drew.fg.histall[parent_host][len])) {
            return;
          }
          if (drew.fg.lib.shExpMatch(drew.fg.histall[parent_host][len].substring(2), wildcard_host)) {
            drew.fg.histall[parent_host].splice(len, 1);
          }
        }
        drew.fg.histall[parent_host].push(wildcard_host);
        drew.fg.timehist[parent_host] = Date.now();
        drew.fg.histall[parent_host].sort();
      }
    }, {urls:["<all_urls>"], types:["sub_frame", "stylesheet", "script", "image", "font", "object", "xmlhttprequest", "ping", "csp_report", "media", "other"]});
    chrome.idle.onStateChanged.addListener(function(newState) {
      if (newState == "active") {
        var n = drew.fg.ls.set("lastgetapi");
        if (n && n > Date.now()) {
          drew.fg.core.LoadConf();
        }
      }
    });
    drew.fg.ls.set("md5.pr", "");
    if (drew.fg.ls.get("f3proxy") == 1) {
      drew.fg.ls.set("mode", 2);
    }
    drew.fg.lib.ReqJson("https://proxyforfrigate.com/api/2/ru/proxy", 1E3 * 30, function(resp) {
      core.oninstalled(resp, function() {
        core.onstartup(true);
      });
    }, function(resp) {
      core.oninstalled(resp, function() {
        core.onstartup(true);
      });
    }, function(resp) {
      core.oninstalled(resp, function() {
        core.onstartup(true);
      });
    });
  };
  return core;
}();
window.addEventListener("load", function load(event) {
  window.removeEventListener("load", load, false);
  drew.fg.lib.debug(3, "start");
  drew.fg.core.start();
}, false);

